#include <sta/rtos/event.hpp>

namespace sta {
    RtosEvent::RtosEvent() {
        osEventFlagsAttr_t attr = { 0 };
        event_id = osEventFlagsNew(&attr);
    }

    RtosEvent::~RtosEvent() {
        osEventFlagsDelete(event_id);
    }

    void RtosEvent::set(uint32_t flags) {
        osEventFlagsSet(event_id, flags);
    }

    void RtosEvent::clear(uint32_t flags) {
        osEventFlagsClear(event_id, flags);
    }

    uint32_t RtosEvent::get() {
        return osEventFlagsGet(event_id);
    }

    uint32_t RtosEvent::wait(uint32_t flags, uint32_t timeout) {
        return osEventFlagsWait(event_id, flags, osFlagsWaitAny, timeout);
    }

} // namespace sta